/*
 * Copyright (c) univento.eu 2016. Any attempt to use these program(s) without permission may result in a penalty of up to 1.000€
 */

package eu.univento.woolget.utils;

import eu.univento.core.api.game.TeamManager;
import eu.univento.core.api.player.CustomPlayer;
import eu.univento.woolget.WoolGet;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;

/**
 * @author joethei
 * @version 0.1
 */
public class TeamChooser {

    private static ArrayList<CustomPlayer> blue = new ArrayList<>();
    private static ArrayList<CustomPlayer> yellow = new ArrayList<>();


    public static Inventory getInventory(CustomPlayer p) {
        Inventory inv = Bukkit.createInventory(p, 9, "§6Team wählen");

        ItemStack blue = new ItemStack(Material.WOOL, 1, (short) 11);
        ItemMeta blueMeta = blue.getItemMeta();
        blueMeta.setDisplayName("§9blue");
        blue.setItemMeta(blueMeta);

        ItemStack yellow = new ItemStack(Material.WOOL, 1, (short) 4);
        ItemMeta yellowMeta = yellow.getItemMeta();
        yellowMeta.setDisplayName("§eyellow");
        yellow.setItemMeta(yellowMeta);

        inv.setItem(2, blue);
        inv.setItem(5, yellow);

        return inv;
    }

    public static void addToTeam(String name, CustomPlayer p) {
        if (blue.contains(p)) blue.remove(p);
        if (yellow.contains(p)) yellow.remove(p);
        if (name.equalsIgnoreCase("blue")) blue.add(p);
        if (name.equalsIgnoreCase("yellow")) yellow.add(p);
    }

    public static void addToTeams() {
        for (CustomPlayer p : blue) {
            TeamManager.getTeam("blue").addPlayer(p);
        }
        for (CustomPlayer p : yellow) {
            TeamManager.getTeam("yellow").addPlayer(p);
        }
        WoolGet.getPlayers().stream().filter(p -> TeamManager.getTeam(p) == null).forEachOrdered(p -> {
            if (TeamManager.getTeam("blue").getPlayers().size() > TeamManager.getTeam("yellow").getPlayers().size()) {
                TeamManager.getTeam("yellow").addPlayer(p);
            }
            if (TeamManager.getTeam("yellow").getPlayers().size() > TeamManager.getTeam("blue").getPlayers().size()) {
                TeamManager.getTeam("blue").addPlayer(p);
            }
        });
    }

}