/*
 * Copyright (c) univento.eu 2016. Any attempt to use these program(s) without permission may result in a penalty of up to 1.000€
 */

package eu.univento.woolget.utils;

import eu.univento.woolget.WoolGet;
import eu.univento.woolget.game.GameStage;
import eu.univento.woolget.game.RestartCounter;
import org.bukkit.Bukkit;

/**
 * @author joethei
 * @version 0.1
 */
public class Utils {

    public static void endGame(GameStage stage) {
        WoolGet.setGameStage(GameStage.Restart);
        WoolGet.restartID = WoolGet.getInstance().getServer().getScheduler().scheduleSyncRepeatingTask(WoolGet.getInstance(), new RestartCounter(), 20L, 20L);
        Bukkit.getScheduler().cancelTask(getSchedulerId(stage));
    }

    private static int getSchedulerId(GameStage gameStage) {
        switch (gameStage) {
            case Lobby: return WoolGet.lobbyID;
            case Warmup: return WoolGet.warmupID;
            case Game: return WoolGet.gameID;
            case Restart: return WoolGet.restartID;
            default: return 0;
        }
    }
}